# Generated by Django 3.2.5 on 2024-02-05 12:26

from decimal import Decimal
import django.contrib.gis.db.models.fields
import django.contrib.postgres.constraints
import django.contrib.postgres.fields.ranges
from django.db import migrations, models
import django.db.models.constraints
import django.db.models.deletion
import django.utils.timezone
import lingua.fields


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('sgpa', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='Permit',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('reference', models.CharField(blank=True, default='', max_length=255)),
                ('date_answer', models.DateField(null=True)),
                ('date_introduced', models.DateField(null=True)),
                ('state', models.CharField(default='pending', max_length=20)),
                ('comment', models.TextField()),
            ],
        ),
        migrations.CreateModel(
            name='Recommendation',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date', models.DateField()),
                ('do_not_follow', models.BooleanField(default=False)),
                ('delay', models.DurationField(null=True)),
            ],
        ),
        migrations.CreateModel(
            name='RecommendationKind',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', lingua.fields.LinguaField(verbose_name='recommandation_kind_label')),
                ('needs_work', models.BooleanField(default=False)),
            ],
        ),
        migrations.CreateModel(
            name='Tree',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('point', django.contrib.gis.db.models.fields.PointField(null=True, srid=4326)),
            ],
        ),
        migrations.CreateModel(
            name='TreeCuttingDisposal',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', lingua.fields.LinguaField(verbose_name='tree_cutting_disposal_label')),
            ],
        ),
        migrations.CreateModel(
            name='TreeEnvironment',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', lingua.fields.LinguaField(verbose_name='tree_environment_label')),
            ],
        ),
        migrations.CreateModel(
            name='TreeEpiphyte',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', lingua.fields.LinguaField(verbose_name='tree_epiphyte_label')),
            ],
        ),
        migrations.CreateModel(
            name='TreePathogen',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', lingua.fields.LinguaField(verbose_name='tree_pathogene_label')),
            ],
        ),
        migrations.CreateModel(
            name='TreePest',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', lingua.fields.LinguaField(verbose_name='tree_pest_label')),
            ],
        ),
        migrations.CreateModel(
            name='TreeReport',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date', models.DateField(default=django.utils.timezone.now)),
            ],
        ),
        migrations.CreateModel(
            name='TreeReportGroup',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date', models.DateField()),
            ],
        ),
        migrations.CreateModel(
            name='TreeStatus',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', lingua.fields.LinguaField(verbose_name='tree_status_label')),
            ],
        ),
        migrations.CreateModel(
            name='TreeStructure',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', lingua.fields.LinguaField(verbose_name='tree_structure_label')),
            ],
        ),
        migrations.CreateModel(
            name='TreeSymptomLeave',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', lingua.fields.LinguaField(verbose_name='tree_symptom_leave_label')),
            ],
        ),
        migrations.CreateModel(
            name='TreeSymptomRoot',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', lingua.fields.LinguaField(verbose_name='tree_symptom_root_label')),
            ],
        ),
        migrations.CreateModel(
            name='TreeSymptomTrunk',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', lingua.fields.LinguaField(verbose_name='tree_symptom_trunk_label')),
            ],
        ),
        migrations.CreateModel(
            name='WorkKind',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', lingua.fields.LinguaField(verbose_name='work_kind_label')),
                ('need_permit', models.BooleanField(default=False)),
                ('active', models.BooleanField(default=False)),
                ('possibility_of', models.ForeignKey(null=True, on_delete=django.db.models.deletion.RESTRICT, to='sgpa.recommendationkind')),
                ('tree_status_after', models.ForeignKey(null=True, on_delete=django.db.models.deletion.RESTRICT, to='sgpa.treestatus')),
            ],
        ),
        migrations.CreateModel(
            name='WorkKindBudget',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', lingua.fields.LinguaField(verbose_name='work_kind_budget_label')),
                ('price', models.DecimalField(decimal_places=2, default=Decimal('0.00'), max_digits=10)),
                ('code', models.TextField(blank=True, default='')),
            ],
        ),
        migrations.CreateModel(
            name='WorkTeam',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', lingua.fields.LinguaField(verbose_name='tree_report_work_team_label')),
                ('can_recommendation', models.BooleanField(default=False)),
                ('can_work', models.BooleanField(default=False)),
                ('is_internal', models.BooleanField(default=False)),
            ],
        ),
        migrations.CreateModel(
            name='WorkTree',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('priority', models.CharField(default='normal', max_length=20)),
                ('due_date', models.DateField(null=True)),
                ('target_date', models.DateField(null=True)),
                ('done_date', models.DateField(null=True)),
                ('state', models.CharField(default='pending', max_length=20)),
                ('comment', models.TextField(blank=True, default='')),
                ('price', models.DecimalField(decimal_places=2, default=Decimal('0.00'), max_digits=10)),
                ('validation_comment', models.TextField(blank=True, default='')),
                ('permit', models.ForeignKey(null=True, on_delete=django.db.models.deletion.RESTRICT, to='sgpa.permit')),
                ('recommendation', models.ForeignKey(null=True, on_delete=django.db.models.deletion.RESTRICT, to='sgpa.recommendation')),
                ('tree', models.ForeignKey(on_delete=django.db.models.deletion.RESTRICT, to='sgpa.tree')),
                ('tree_cutting_disposal', models.ForeignKey(null=True, on_delete=django.db.models.deletion.RESTRICT, to='sgpa.treecuttingdisposal')),
                ('work_kind', models.ForeignKey(null=True, on_delete=django.db.models.deletion.RESTRICT, to='sgpa.workkind')),
            ],
        ),
        migrations.CreateModel(
            name='Work',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('status', models.CharField(default='draft', max_length=20)),
                ('done_by', models.ForeignKey(null=True, on_delete=django.db.models.deletion.RESTRICT, to='sgpa.workteam')),
            ],
        ),
        migrations.CreateModel(
            name='TreeVitalityHistory',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('validity', django.contrib.postgres.fields.ranges.DateRangeField()),
                ('vitality', models.PositiveSmallIntegerField(default=0)),
                ('report', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='sgpa.treereport')),
                ('tree', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='vitality_history', to='sgpa.tree')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TreeSymptomTrunkHistory',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('validity', django.contrib.postgres.fields.ranges.DateRangeField()),
                ('report', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='sgpa.treereport')),
                ('symptom', models.ForeignKey(on_delete=django.db.models.deletion.RESTRICT, to='sgpa.treesymptomtrunk')),
                ('tree', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='symptom_trunk_history', to='sgpa.tree')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TreeSymptomRootHistory',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('validity', django.contrib.postgres.fields.ranges.DateRangeField()),
                ('report', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='sgpa.treereport')),
                ('symptom', models.ForeignKey(on_delete=django.db.models.deletion.RESTRICT, to='sgpa.treesymptomroot')),
                ('tree', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='symptom_root_history', to='sgpa.tree')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TreeSymptomLeaveHistory',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('validity', django.contrib.postgres.fields.ranges.DateRangeField()),
                ('report', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='sgpa.treereport')),
                ('symptom', models.ForeignKey(on_delete=django.db.models.deletion.RESTRICT, to='sgpa.treesymptomleave')),
                ('tree', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='symptom_leave_history', to='sgpa.tree')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TreeStructureHistory',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('validity', django.contrib.postgres.fields.ranges.DateRangeField()),
                ('report', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='sgpa.treereport')),
                ('structure', models.ForeignKey(on_delete=django.db.models.deletion.RESTRICT, to='sgpa.treestructure')),
                ('tree', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='structure_history', to='sgpa.tree')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TreeStatusHistory',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('validity', django.contrib.postgres.fields.ranges.DateRangeField()),
                ('report', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='sgpa.treereport')),
                ('status', models.ForeignKey(on_delete=django.db.models.deletion.RESTRICT, to='sgpa.treestatus')),
                ('tree', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='status_history', to='sgpa.tree')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TreeRiskAnalysisHistory',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('validity', django.contrib.postgres.fields.ranges.DateRangeField()),
                ('break_risk', models.PositiveSmallIntegerField()),
                ('size_risk', models.PositiveSmallIntegerField()),
                ('target_risk', models.PositiveSmallIntegerField()),
                ('report', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='sgpa.treereport')),
                ('tree', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='risk_analysis_history', to='sgpa.tree')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='treereport',
            name='done_by',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.RESTRICT, to='sgpa.workteam'),
        ),
        migrations.AddField(
            model_name='treereport',
            name='group',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.RESTRICT, to='sgpa.treereportgroup'),
        ),
        migrations.AddField(
            model_name='treereport',
            name='tree',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.RESTRICT, to='sgpa.tree'),
        ),
        migrations.CreateModel(
            name='TreePestHistory',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('validity', django.contrib.postgres.fields.ranges.DateRangeField()),
                ('pest', models.ForeignKey(on_delete=django.db.models.deletion.RESTRICT, to='sgpa.treepest')),
                ('report', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='sgpa.treereport')),
                ('tree', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='pest_history', to='sgpa.tree')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TreePathogenHistory',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('validity', django.contrib.postgres.fields.ranges.DateRangeField()),
                ('pathogen', models.ForeignKey(on_delete=django.db.models.deletion.RESTRICT, to='sgpa.treepathogen')),
                ('report', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='sgpa.treereport')),
                ('tree', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='pathogen_history', to='sgpa.tree')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TreeOntogenesisHistory',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('validity', django.contrib.postgres.fields.ranges.DateRangeField()),
                ('ontogenesis', models.PositiveSmallIntegerField()),
                ('report', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='sgpa.treereport')),
                ('tree', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='ontogenesis_history', to='sgpa.tree')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TreeKind',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', models.TextField(default='')),
                ('common_name', lingua.fields.LinguaField(blank=True, null=True, verbose_name='tree_kind_common_name')),
                ('parent', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='sgpa.treekind')),
            ],
        ),
        migrations.CreateModel(
            name='TreeEpiphyteHistory',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('validity', django.contrib.postgres.fields.ranges.DateRangeField()),
                ('epiphyte', models.ForeignKey(on_delete=django.db.models.deletion.RESTRICT, to='sgpa.treeepiphyte')),
                ('report', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='sgpa.treereport')),
                ('tree', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='epiphyte_history', to='sgpa.tree')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TreeEnvironmentHistory',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('validity', django.contrib.postgres.fields.ranges.DateRangeField()),
                ('environments', models.ManyToManyField(to='sgpa.TreeEnvironment')),
                ('report', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='sgpa.treereport')),
                ('tree', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='environment_history', to='sgpa.tree')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TreeDendrometryHistory',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('validity', django.contrib.postgres.fields.ranges.DateRangeField()),
                ('height', models.DecimalField(decimal_places=3, max_digits=10)),
                ('circumference150', models.DecimalField(decimal_places=3, max_digits=10)),
                ('crown_diameter_range', django.contrib.postgres.fields.ranges.DecimalRangeField()),
                ('branches_count', models.PositiveIntegerField(default=1)),
                ('report', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='sgpa.treereport')),
                ('tree', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='dendrometry_history', to='sgpa.tree')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='tree',
            name='kind',
            field=models.ForeignKey(on_delete=django.db.models.deletion.RESTRICT, to='sgpa.treekind'),
        ),
        migrations.AddField(
            model_name='recommendation',
            name='recommendation',
            field=models.ForeignKey(on_delete=django.db.models.deletion.RESTRICT, to='sgpa.recommendationkind'),
        ),
        migrations.AddField(
            model_name='recommendation',
            name='report',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='sgpa.treereport'),
        ),
        migrations.AddField(
            model_name='recommendation',
            name='tree',
            field=models.ForeignKey(on_delete=django.db.models.deletion.RESTRICT, to='sgpa.tree'),
        ),
        migrations.AddConstraint(
            model_name='treevitalityhistory',
            constraint=django.contrib.postgres.constraints.ExclusionConstraint(deferrable=django.db.models.constraints.Deferrable['DEFERRED'], expressions=[('validity', '&&'), ('tree', '=')], name='history_exclusion_vitality_history'),
        ),
        migrations.AddConstraint(
            model_name='treesymptomtrunkhistory',
            constraint=django.contrib.postgres.constraints.ExclusionConstraint(deferrable=django.db.models.constraints.Deferrable['DEFERRED'], expressions=[('validity', '&&'), ('tree', '=')], name='history_exclusion_symptom_trunk_history'),
        ),
        migrations.AddConstraint(
            model_name='treesymptomroothistory',
            constraint=django.contrib.postgres.constraints.ExclusionConstraint(deferrable=django.db.models.constraints.Deferrable['DEFERRED'], expressions=[('validity', '&&'), ('tree', '=')], name='history_exclusion_symptom_root_history'),
        ),
        migrations.AddConstraint(
            model_name='treesymptomleavehistory',
            constraint=django.contrib.postgres.constraints.ExclusionConstraint(deferrable=django.db.models.constraints.Deferrable['DEFERRED'], expressions=[('validity', '&&'), ('tree', '=')], name='history_exclusion_symptom_leave_history'),
        ),
        migrations.AddConstraint(
            model_name='treestructurehistory',
            constraint=django.contrib.postgres.constraints.ExclusionConstraint(deferrable=django.db.models.constraints.Deferrable['DEFERRED'], expressions=[('validity', '&&'), ('tree', '=')], name='history_exclusion_structure_history'),
        ),
        migrations.AddConstraint(
            model_name='treestatushistory',
            constraint=django.contrib.postgres.constraints.ExclusionConstraint(deferrable=django.db.models.constraints.Deferrable['DEFERRED'], expressions=[('validity', '&&'), ('tree', '=')], name='history_exclusion_status_history'),
        ),
        migrations.AddConstraint(
            model_name='treeriskanalysishistory',
            constraint=django.contrib.postgres.constraints.ExclusionConstraint(deferrable=django.db.models.constraints.Deferrable['DEFERRED'], expressions=[('validity', '&&'), ('tree', '=')], name='history_exclusion_risk_analysis_history'),
        ),
        migrations.AddConstraint(
            model_name='treepesthistory',
            constraint=django.contrib.postgres.constraints.ExclusionConstraint(deferrable=django.db.models.constraints.Deferrable['DEFERRED'], expressions=[('validity', '&&'), ('tree', '=')], name='history_exclusion_pest_history'),
        ),
        migrations.AddConstraint(
            model_name='treepathogenhistory',
            constraint=django.contrib.postgres.constraints.ExclusionConstraint(deferrable=django.db.models.constraints.Deferrable['DEFERRED'], expressions=[('validity', '&&'), ('tree', '=')], name='history_exclusion_pathogen_history'),
        ),
        migrations.AddConstraint(
            model_name='treeontogenesishistory',
            constraint=django.contrib.postgres.constraints.ExclusionConstraint(deferrable=django.db.models.constraints.Deferrable['DEFERRED'], expressions=[('validity', '&&'), ('tree', '=')], name='history_exclusion_ontogenesis_history'),
        ),
        migrations.AddConstraint(
            model_name='treeepiphytehistory',
            constraint=django.contrib.postgres.constraints.ExclusionConstraint(deferrable=django.db.models.constraints.Deferrable['DEFERRED'], expressions=[('validity', '&&'), ('tree', '=')], name='history_exclusion_epiphyte_history'),
        ),
        migrations.AddConstraint(
            model_name='treeenvironmenthistory',
            constraint=django.contrib.postgres.constraints.ExclusionConstraint(deferrable=django.db.models.constraints.Deferrable['DEFERRED'], expressions=[('validity', '&&'), ('tree', '=')], name='history_exclusion_environment_history'),
        ),
        migrations.AddConstraint(
            model_name='treedendrometryhistory',
            constraint=django.contrib.postgres.constraints.ExclusionConstraint(deferrable=django.db.models.constraints.Deferrable['DEFERRED'], expressions=[('validity', '&&'), ('tree', '=')], name='history_exclusion_dendrometry_history'),
        ),
    ]
